// AxiPile_Tabs.inc ( an Aurora include file, executable source file is AxiPile.src )
// by John Siino
// 02/12/07

#define PROG_TITLE "AxiPile (c)2007"

#define WIDTH  600
#define HEIGHT 400
#define TABHT  40

#define TAB_1 1

#define StaticLeft   0x50000000   // multiline left justify
#define StaticCntr   0x50000001   // multiline center justify
#define StaticRght   0x50000002   // multiline right justify

// About
#define ABT_Static_11 11
#define ABOUT_OK 12
#define ABT_Text_11 "AxiPile (c) 2007\n\nUniversity of Nevada, Reno\n\nJohn M. Siino,\nSherif Elfass\nand\nGary Norris"
#define ABT_W 200
#define ABT_H 160

// Project Info
#define STATIC_201		201
#define EDIT_PDESC		202
#define STATIC_203		203
#define EDIT_PNAME		204
#define STATIC_205		205
#define EDIT_PNUM		206
#define STATIC_207		207
#define EDIT_PLOC		208
#define STATIC_209		209
#define EDIT_PENG		210
#define STATIC_211		211
#define EDIT_PCOM		212
#define STATIC_213		213
#define EDIT_PDAT		214
#define DONE_BUTTON		215
#define CLR_BUTTON		216

// Pile Info
#define GROUP_301		301
#define GROUP_302		302
#define STATIC_303		303
#define Fc_EDIT			304
#define STATIC_305		305
#define Butt_A_EDIT		306
#define STATIC_307		307
#define Tip_A_EDIT		308
#define STATIC_309		309

#define SEND_BUTTON		310
#define NTp_CHECK		311
#define Tap_CHECK		312
#define Rnd_CHECK		313
#define Sqr_CHECK		314
#define Oth_CHECK		315
#define CNC_CHECK		316
#define STL_CHECK		317
#define WD_CHECK		318

#define STATIC_319		319
#define Butt_D_EDIT		320
#define Tip_D_EDIT		321
#define STATIC_322		322
#define Butt_EA_EDIT	323
#define Tip_EA_EDIT		324
#define STATIC_325		325
#define STATIC_326		326
#define STATIC_327		327
#define L_EDIT			328
#define E_EDIT			329

// soil info
#define SOIL_DESC_GROUP		400
#define STATIC_401			401
#define EDIT_NUMLAYERS		402
#define STATIC_403			403
#define EDIT_TOTDEPTH		404

#define SOIL_PROP_GROUP 	500
#define EDIT_LAYERNO	 	501
#define SPIN_LAYERNO	 	502
#define CHECK_SAND 			503
#define CHECK_CLAY 			504
#define CHECK_CPHI 			505
#define CHECK_GWT 			506

#define EDIT_THICKNESS 		601
#define EDIT_SATWEIGHT 		602
#define EDIT_BOUYANTWT		603
#define EDIT_DEPTH			604
#define EDIT_DR 			605
#define EDIT_PHI 			606
#define EDIT_CUU			607
#define EDIT_TOTSTRESS 		608
#define EDIT_EPSILON50 		609

#define STATIC_610			610
#define STATIC_611			611
#define STATIC_612			612
#define STATIC_613			613
#define STATIC_614			614
#define STATIC_615			615
#define STATIC_616			616
#define STATIC_617			617
#define STATIC_618			618

#define SCHEMATIC_GROUP		700



class TabDlg:CDialog
{
	declare OnInitDialog(),int;
	declare OnClose(),int;
	declare OnControl(int nID, int nNotifyCode, unsigned int hControl),int;

	declare Refresh_Values();

	//member pointers to copy the control class pointers into.
	CTabCtrl *m_tab1;

	// about pointers
	CButton  *m_abt_btn1;
	CStatic  *m_abt_txt;
	// project info pointers
	CControl *m_proj_info[17];
	
	// pile info pointers
	CControl *m_pile_info[30];
	CButton  *m_pile_bttn[9];
	
	// soil info pointers
	CControl *m_soil_info[31];
	CControl *m_4soil_info[5];
	CControl *m_5soil_info[7];
	CControl *m_6soil_info[19];
	CControl *m_7soil_info;
	//CButton  *m_pile_bttn[9];


	//member variables
	public:
	double BD, TD, BA, TA, E;
	int ErrorFlag, Flag, PileFirstTime, SoilFirstTime;
}


TabDlg::OnClose(),int
{
	CloseDialog(1);
return true;
}


// 			Initialize all pointers and controls (tabs, etc.)
TabDlg::OnInitDialog(),int
{
	m_tab1		= GetControl(TAB_1);

	// about pointers
	m_abt_txt	= GetControl(ABT_Static_11);
	m_abt_btn1	= GetControl(ABOUT_OK);

	// project info pointers
	for ( int i = 1; i < 17; i++ )
		{ 
			m_proj_info[i] = GetControl(200+i);
		}

	// pile info pointers
	for ( i = 1; i < 30; i++ )
		{ 
			m_pile_info[i] = GetControl(300+i);
		}

	for ( i = 0; i < 9; i++ )
		{ 
			m_pile_bttn[i] = GetControl(310+i);
		}


	// soil info pointers
	for ( i = 0; i < 5; i++ )
		{ 
			m_4soil_info[i] = GetControl(400+i);
			m_soil_info[i] = GetControl(400+i);
		}

	for ( i = 0; i < 7; i++ )
		{ 
			m_5soil_info[i] = GetControl(500+i);
			m_soil_info[i+5] = GetControl(500+i);
		}

	for ( i = 1; i < 19; i++ )
		{ 
			m_6soil_info[i] = GetControl(600+i);
			m_soil_info[i+5+6] = GetControl(600+i);
		}

	m_7soil_info = GetControl(700);
	m_soil_info[5+6+18+1] = GetControl(700);  // 5+6+18+1 = 30



	// Initialize any controls here
		m_tab1->SetFont("Arial",10,400,0);
		m_tab1->SetColor(RGB(0,0,0), RGB(255,255,255));
		m_tab1->InsertTab(0,"About");
		m_tab1->InsertTab(1,"Project Info");
		m_tab1->InsertTab(2,"Pile Info");
		m_tab1->InsertTab(3,"Soil Info");
		m_tab1->InsertTab(4,"Review Soil and Pile Info");
		m_tab1->InsertTab(5,"Analyze");
		
	//tooltips for the tabs
		for ( i = 0; i < 6; i++ )
			{
				m_tab1->SetTip (i, m_tab1->GetTabText(i));
			}
	
	// about
		m_abt_txt->SetFont("Arial",11,700,0);
		m_abt_btn1->ShowWindow(SWSHOW);
		m_abt_txt->ShowWindow(SWSHOW);

	// project info
	for ( i = 1; i < 17; i++ )
		{ 
			m_proj_info[i]->ShowWindow(SWHIDE);
		}

	// pile info
		m_pile_bttn[NTp_CHECK-310]->SetCheck(TRUE);
		m_pile_bttn[Rnd_CHECK-310]->SetCheck(TRUE);
		m_pile_bttn[CNC_CHECK-310]->SetCheck(TRUE);

	for ( i = 1; i < 30; i++ )
		{ 
			m_pile_info[i]->ShowWindow(SWHIDE);
		}

	// soil info
	for ( i = 0; i < 31; i++ )
		{ 
			m_soil_info[i]->ShowWindow(SWHIDE);
		}

	

	CenterWindow();
return true;
}


TabDlg::OnControl(int nID, int nNotifyCode, unsigned int hControl),int
{
	select nID
	{
		case TAB_1:
			/* respond to control notifications here */
			if(nNotifyCode = TCNSELCHANGE)
			{
				nTab = m_tab1->GetSelectedTab();
				switch(nTab) {

					// 								start Tab tests
					case 0:
						// about
						m_abt_btn1->ShowWindow(SWSHOW);
						m_abt_txt->ShowWindow(SWSHOW);
						// project info
						for ( i = 1; i < 17; i++ )
							{ 
								m_proj_info[i]->ShowWindow(SWHIDE);
							}
						// pile info
						for ( i = 1; i < 30; i++ )
							{ 
								m_pile_info[i]->ShowWindow(SWHIDE);
							}
						// soil info
						for ( i = 0; i < 31; i++ )
							{ 
								m_soil_info[i]->ShowWindow(SWHIDE);
							}


					case 1:
						// about
						m_abt_btn1->ShowWindow(SWHIDE);
						m_abt_txt->ShowWindow(SWHIDE);
						// project info
						for ( i = 1; i < 17; i++ )
							{ 
								m_proj_info[i]->ShowWindow(SWSHOW);
							}
						// pile info
						for ( i = 1; i < 30; i++ )
							{ 
								m_pile_info[i]->ShowWindow(SWHIDE);
							}
						// soil info
						for ( i = 0; i < 31; i++ )
							{ 
								m_soil_info[i]->ShowWindow(SWHIDE);
							}

					case 2:
						// about
						m_abt_btn1->ShowWindow(SWHIDE);
						m_abt_txt->ShowWindow(SWHIDE);
						// project info
						for ( i = 1; i < 17; i++ )
							{ 
								m_proj_info[i]->ShowWindow(SWHIDE);
							}
						// pile info
						for ( i = 1; i < 30; i++ )
							{ 
								m_pile_info[i]->ShowWindow(SWSHOW);
							}

						if ( m_pile_bttn[NTp_CHECK-310]->GetCheck() )
							{
								m_pile_info[ STATIC_307-300]->ShowWindow(SWHIDE);
								m_pile_info[ Tip_A_EDIT-300]->ShowWindow(SWHIDE);
								m_pile_info[ Tip_D_EDIT-300]->ShowWindow(SWHIDE);
								m_pile_info[Tip_EA_EDIT-300]->ShowWindow(SWHIDE);
								m_pile_info[ STATIC_325-300]->ShowWindow(SWHIDE);
								m_pile_info[ STATIC_326-300]->ShowWindow(SWHIDE);
							}

						// soil info
						for ( i = 0; i < 31; i++ )
							{ 
								m_soil_info[i]->ShowWindow(SWHIDE);
							}

					case 3:
						// about
						m_abt_btn1->ShowWindow(SWHIDE);
						m_abt_txt->ShowWindow(SWHIDE);
						// project info
						for ( i = 1; i < 17; i++ )
							{ 
								m_proj_info[i]->ShowWindow(SWHIDE);
							}
						// pile info
						for ( i = 1; i < 30; i++ )
							{ 
								m_pile_info[i]->ShowWindow(SWHIDE);
							}
						// soil info
						for ( i = 0; i < 31; i++ )
							{ 
								m_soil_info[i]->ShowWindow(SWSHOW);
							}

					case 4:
						// about
						m_abt_btn1->ShowWindow(SWHIDE);
						m_abt_txt->ShowWindow(SWHIDE);
						// project info
						for ( i = 1; i < 17; i++ )
							{ 
								m_proj_info[i]->ShowWindow(SWHIDE);
							}
						// pile info
						for ( i = 1; i < 30; i++ )
							{ 
								m_pile_info[i]->ShowWindow(SWHIDE);
							}
						// soil info
						for ( i = 0; i < 31; i++ )
							{ 
								m_soil_info[i]->ShowWindow(SWHIDE);
							}

					case 5:
						// about
						m_abt_btn1->ShowWindow(SWHIDE);
						m_abt_txt->ShowWindow(SWHIDE);
						// project info
						for ( i = 1; i < 17; i++ )
							{ 
								m_proj_info[i]->ShowWindow(SWHIDE);
							}
						// pile info
						for ( i = 1; i < 30; i++ )
							{ 
								m_pile_info[i]->ShowWindow(SWHIDE);
							}
						// soil info
						for ( i = 0; i < 31; i++ )
							{ 
								m_soil_info[i]->ShowWindow(SWHIDE);
							}

				}
			}
			return false;


		// 									start About Tab tests
		case ABOUT_OK:				// button clicked
			if(nNotifyCode = 0)
			{
				m_tab1->SetFocusTab(1);
				// about
				m_abt_btn1->ShowWindow(SWHIDE);
				m_abt_txt->ShowWindow(SWHIDE);
				// project info
				for ( i = 1; i < 17; i++ )
					{ 
						m_proj_info[i]->ShowWindow(SWSHOW);
					}
			}


		// 									start Project Info Tab tests
		case DONE_BUTTON:			// button clicked
			// about
			m_abt_btn1->ShowWindow(SWHIDE);
			m_abt_txt->ShowWindow(SWHIDE);
			// project info
			for ( i = 1; i < 17; i++ )
				{ 
					m_proj_info[i]->ShowWindow(SWHIDE);
				}
			// pile info
			for ( i = 1; i < 30; i++ )
				{ 
					m_pile_info[i]->ShowWindow(SWSHOW);
				}
			if ( m_pile_bttn[NTp_CHECK-310]->GetCheck() )
				{
					m_pile_info[ STATIC_307-300]->ShowWindow(SWHIDE);
					m_pile_info[ Tip_A_EDIT-300]->ShowWindow(SWHIDE);
					m_pile_info[ Tip_D_EDIT-300]->ShowWindow(SWHIDE);
					m_pile_info[Tip_EA_EDIT-300]->ShowWindow(SWHIDE);
					m_pile_info[ STATIC_325-300]->ShowWindow(SWHIDE);
					m_pile_info[ STATIC_326-300]->ShowWindow(SWHIDE);
				}
			m_pile_bttn[Rnd_CHECK-310]->SetCheck(TRUE);
			m_pile_bttn[CNC_CHECK-310]->SetCheck(TRUE);

		case CLR_BUTTON:			// clear project info button clicked
			if(nNotifyCode = 0)
			{
				for ( i = 2; i < 15; i=i+2 )
					{ 
						m_proj_info[i]->SetText("");
					}
			}


		// 									start Pile Info Tab tests
		case Rnd_CHECK:
				m_pile_bttn[ Rnd_CHECK-310]->SetCheck(TRUE);
				m_pile_bttn[ Sqr_CHECK-310]->SetCheck(FALSE);
				m_pile_bttn[ Oth_CHECK-310]->SetCheck(FALSE);
				m_pile_info[STATIC_319-300]->SetText("Diameter (ft)");
				Refresh_Values();

		case Sqr_CHECK:
				m_pile_bttn[ Rnd_CHECK-310]->SetCheck(FALSE);
				m_pile_bttn[ Sqr_CHECK-310]->SetCheck(TRUE);
				m_pile_bttn[ Oth_CHECK-310]->SetCheck(FALSE);
				m_pile_info[STATIC_319-300]->SetText("Side Width (ft)");
				Refresh_Values();

		case Oth_CHECK:
				m_pile_bttn[Oth_CHECK-310]->SetCheck(FALSE);  // DISABLED

		case NTp_CHECK:
				m_pile_bttn[  NTp_CHECK-310]->SetCheck(TRUE);
				m_pile_bttn[  Tap_CHECK-310]->SetCheck(FALSE);
				m_pile_info[ STATIC_305-300]->SetText("Area, A (sq.in.)");
				m_pile_info[ STATIC_307-300]->ShowWindow(SWHIDE);
				m_pile_info[ Tip_A_EDIT-300]->ShowWindow(SWHIDE);
				m_pile_info[ Tip_D_EDIT-300]->ShowWindow(SWHIDE);
				m_pile_info[Tip_EA_EDIT-300]->ShowWindow(SWHIDE);
				m_pile_info[ STATIC_325-300]->ShowWindow(SWHIDE);
				m_pile_info[ STATIC_326-300]->ShowWindow(SWHIDE);
				Refresh_Values();

		case Tap_CHECK:
				m_pile_bttn[  NTp_CHECK-310]->SetCheck(FALSE);
				m_pile_bttn[  Tap_CHECK-310]->SetCheck(TRUE);
				m_pile_info[ STATIC_305-300]->SetText("Butt Area, A (sq.in.)");
				m_pile_info[ STATIC_307-300]->ShowWindow(SWSHOW);
				m_pile_info[ Tip_A_EDIT-300]->ShowWindow(SWSHOW);
				m_pile_info[ Tip_D_EDIT-300]->ShowWindow(SWSHOW);
				m_pile_info[Tip_EA_EDIT-300]->ShowWindow(SWSHOW);
				m_pile_info[ STATIC_325-300]->ShowWindow(SWSHOW);
				m_pile_info[ STATIC_326-300]->ShowWindow(SWSHOW);
				Refresh_Values();


		case CNC_CHECK:
				m_pile_bttn[ CNC_CHECK-310]->SetCheck(TRUE);
				m_pile_bttn[ STL_CHECK-310]->SetCheck(FALSE);
				m_pile_bttn[  WD_CHECK-310]->SetCheck(FALSE);
				m_pile_info[STATIC_303-300]->ShowWindow(SWSHOW);
				m_pile_info[   Fc_EDIT-300]->ShowWindow(SWSHOW);
				Refresh_Values();

		case STL_CHECK:
				m_pile_bttn[ CNC_CHECK-310]->SetCheck(FALSE);
				m_pile_bttn[ STL_CHECK-310]->SetCheck(TRUE);
				m_pile_bttn[  WD_CHECK-310]->SetCheck(FALSE);
				m_pile_info[STATIC_303-300]->ShowWindow(SWHIDE);
				m_pile_info[   Fc_EDIT-300]->ShowWindow(SWHIDE);
				m_pile_info[  E_EDIT-300]->SetText("29000");
				Refresh_Values();

		case WD_CHECK:
				m_pile_bttn[ CNC_CHECK-310]->SetCheck(FALSE);
				m_pile_bttn[ STL_CHECK-310]->SetCheck(FALSE);
				m_pile_bttn[  WD_CHECK-310]->SetCheck(TRUE);
				m_pile_info[STATIC_303-300]->ShowWindow(SWHIDE);
				m_pile_info[   Fc_EDIT-300]->ShowWindow(SWHIDE);
				m_pile_info[  E_EDIT-300]->SetText("1800");
				Refresh_Values();

		case Butt_D_EDIT:
			Refresh_Values();

		case Tip_D_EDIT:
			Refresh_Values();

		case Fc_EDIT:
			Refresh_Values();

		case Butt_A_EDIT:
			m_pile_info[Butt_EA_EDIT-300]->SetText( NumToStr( E * BA, 2 ) );

		case Tip_A_EDIT:
			m_pile_info[ Tip_EA_EDIT-300]->SetText( NumToStr( E * TA, 2 ) );

		case Butt_EA_EDIT:
			/* respond to edit notifications here */

		case Tip_EA_EDIT:
			/* respond to edit notifications here */

		case E_EDIT:
			E = StrToNum( m_pile_info[E_EDIT-300]->GetText() );
			m_pile_info[Butt_EA_EDIT-300]->SetText( NumToStr( E * BA, 2 ) );
			m_pile_info[ Tip_EA_EDIT-300]->SetText( NumToStr( E * TA, 2 ) );

		case SEND_BUTTON:
			if(nNotifyCode = 0)
			{
				/*button clicked*/
			}

		case L_EDIT:
			/* respond to edit notifications here */


		// 									start Soil Info Tab tests
		case EDIT_DR:
			/* respond to edit notifications here */
		case EDIT_PHI:
			/* respond to edit notifications here */
		case EDIT_TOTSTRESS:
			/* respond to edit notifications here */
		case EDIT_EPSILON50:
			/* respond to edit notifications here */

		case EDIT_LAYERNO:
		case SPIN_LAYERNO:

		case CHECK_SAND:
		case CHECK_CLAY:
		case CHECK_CPHI:
		case CHECK_GWT:
		
		case EDIT_CUU:
			/* respond to edit notifications here */
		case EDIT_DEPTH:
			/* respond to edit notifications here */
		case EDIT_BOUYANTWT:
			/* respond to edit notifications here */
		case EDIT_SATWEIGHT:
			/* respond to edit notifications here */
		case EDIT_THICKNESS:
			/* respond to edit notifications here */
		case EDIT_NUMLAYERS:
			/* respond to edit notifications here */
		case EDIT_TOTDEPTH:
			/* respond to edit notifications here */

	}
return true;
}

TabDlg::Refresh_Values()
{
BA=0.0; TA=0.0; E=0.0;
BD = StrToNum( m_pile_info[Butt_D_EDIT-300]->GetText() );

if ( m_pile_bttn[NTp_CHECK-310]->GetCheck() )
	{
		TD = BD;	
	}
	else
	{
		TD = StrToNum( m_pile_info[Tip_D_EDIT-300]->GetText() );
	}

if (m_pile_bttn[Rnd_CHECK-310]->GetCheck())
	{
		BA = 3.14159 * ( BD / 2 )^2;
		TA = 3.14159 * ( TD / 2 )^2;
	}
	else
	{
		BA = BD^2;
		TA = TD^2;
	}

if (m_pile_bttn[CNC_CHECK-310]->GetCheck())
	{
		E = 57 * SQRT((1000 * StrToNum( m_pile_info[Fc_EDIT-300]->GetText())) );
	}
	else
	{
		E = StrToNum( m_pile_info[E_EDIT-300]->GetText() );
	}

m_pile_info[Butt_A_EDIT-300]->SetText( NumToStr( BA, 3 ) );
m_pile_info[ Tip_A_EDIT-300]->SetText( NumToStr( TA, 3 ) );

m_pile_info[ E_EDIT-300]->SetText( NumToStr( E, 1 ) );

m_pile_info[Butt_EA_EDIT-300]->SetText( NumToStr( E * BA, 2 ) );
m_pile_info[ Tip_EA_EDIT-300]->SetText( NumToStr( E * TA, 2 ) );

return;
}


/*
global sub main()
{
	StartAxiPile_Tabs();
return 0;
}


304 Fc_EDIT

306 Butt_A_EDIT
308 Tip_A_EDIT

320 Butt_D_EDIT
321 Tip_D_EDIT

323 Butt_EA_EDIT
324 Tip_EA_EDIT

328 L_EDIT
329 E_EDIT

Flag = MessageBox(NULL,"BD = "+NumToStr(BD,3)+"\nTD = "+NumToStr(TD,3)+"\nBA = "+NumToStr(BA,3)+"\nTA = "+NumToStr(TA,3),"Refresh",MB_OK);
Flag = MessageBox(NULL,"Butt_A_EDIT-300 = "+NumToStr(Butt_A_EDIT-300,0),"Refresh",MB_OK);
Flag = MessageBox(NULL,"m_pile_info[Butt_A_EDIT-300] = "+NumToStr(m_pile_info[Butt_A_EDIT-300],0),"Refresh",MB_OK);

*/